Codeforces Round 957 (Div. 3) A-G 題解

Showball發表於2024-07-12

Codeforces Round 957 (Div. 3) A-G 題解

A. Only Pluses 列舉

思路

列舉 \(a\) , \(b\) , \(c\) 增加的次數,維護最值即可。

程式碼

#include<bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define pb push_back
#define all(u) u.begin(), u.end()
#define endl '\n'
#define debug(x) cout<<#x<<":"<<x<<endl;

typedef pair<int, int> PII;
typedef long long LL;
const int inf = 0x3f3f3f3f;
const int N = 1e5 + 10, M = 105;
const int mod = 1e9 + 7;
const int cases = 1;

void Showball(){
   int a,b,c;
   cin>>a>>b>>c;
   int ans=a*b*c;
   for(int i=0;i<=5;i++){
      for(int j=0;j+i<=5;j++){
         for(int k=0;i+j+k<=5;k++){
            ans=max(ans,(a+i)*(b+j)*(c+k));
         }
      }
   }
   cout<<ans<<endl; 
}
int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int T=1;
    if(cases) cin>>T;
    while(T--)
    Showball();
    return 0;
}

B. Angry Monk 貪心

思路

貪心,最小運算元一定是將除了最大值其餘全部分成 \(1\),然後再依次與最大值合併即可。

程式碼

void Showball(){
   int n,k;
   cin>>n>>k;
   vector<int> a(k);
   for(int i=0;i<k;i++) cin>>a[i];
   sort(all(a));
   int ans=0;
   for(int i=0;i<k-1;i++) ans+=(a[i]-1);
   cout<<ans+n-a[k-1]<<endl;
}

C. Gorilla and Permutation 構造

思路

顯然,先放所有大於等於 \(k\) 的數,並且從大到小放。

接著如果 \(m < k\),那麼將 \(m+1\)\(k-1\) 之間的數放置。

最後放所有小於等於 \(m\) 的數,從小到大放即可。

程式碼

void Showball(){
   int n,m,k;
   cin>>n>>m>>k;
   for(int i=n;i>=k;i--) cout<<i<<" ";
   for(int i=m+1;i<k;i++) cout<<i<<" ";
   for(int i=1;i<min(m+1,k);i++) cout<<i<<" ";
   cout<<endl;
}

D. Test of Love 貪心 + 模擬

思路

貪心,顯然為了能夠更少的去水裡遊,我們的策略自然就是能跳上圓木就上圓木,

否則只能下水,游到下一個圓木。因此我們只需要依次處理兩個圓木。如果可以直接到達,

則直接跳過去,否則直接跳到能跳到的最遠距離。(如果最遠距離是鱷魚的話,說明無法到達。為什麼直接可以跳到最遠距離。因為你在水中想要游到下一個圓木,就必須走過兩者之間的所有河段。那麼你跳到之前的水中,後面有鱷魚,自然也是不滿足情況的。因此,直接跳最遠距離判斷能簡化問題。)

如果最遠距離是水,那麼我們還要判斷從當前河段的水到下一圓木之間是否都是水,這樣才能走過 。反之,無法到達。記錄遊過的距離。

最後如果可以到達終點,並且遊過的距離不超過 \(k\) 米,則滿足題意。

TIPS:我們可以給字串首尾增加一個 “L”,方便我們處理。

程式碼

void Showball(){
   int n,m,k;
   cin>>n>>m>>k;
   string s;
   cin>>s;
   s="L"+s+"L";
   n+=2;
   int cur=0,ans=0;
   while(cur<n-1){
      int p=s.find("L",cur+1);
      if(p==-1) break;
      if(p-cur<=m) {
         cur=p;
         continue;
      }
      cur+=m;
      if(s[cur]=='C') break;
      string tmp=s.substr(cur,p-cur);
      if(tmp!=string(p-cur,'W')) break;
      ans+=p-cur;
      cur=p;
   }
   if(cur<n-1||ans>k) cout<<"NO\n";
   else cout<<"YES\n";
}

E. Novice's Mistake 思維 + 列舉

思路

看到資料範圍不大,考慮列舉。但是不能直接列舉 \(a\)\(b\)

我們發現 \(n*a\) 的最大值是 \(1000000\) 。那麼 \(n*a-b\) 最多也就是一個六位數。

因此我們可以列舉 \(n*a-b\) 的位數,這樣 \(b\) 也就是已知的了。模擬求出對應字串

對比一下是否相等即可。

程式碼

void Showball(){
   int n;
   cin>>n;
   vector<PII> res;
   string sn=to_string(n);
   for(int i=1;i<=10000;i++){
   	  string na="";
   	  while(na.size()<10) na+=sn;
   	  int len=sn.size();
   	  for(int j=1;j<=6;j++){
   	  	int b=i*len-j;
   	  	int ans=n*i-b;
   	  	if(b<1||b>min(10000,n*i)) continue;
   	  	string sans=to_string(ans);
   	  	string sres=na.substr(0,j);
   	  	if(sans==sres){
   	  		res.pb({i,b});
   	  	}
   	  }
   } 
   cout<<res.size()<<endl;
   for(auto [a,b]:res) cout<<a<<" "<<b<<endl;
}

F. Valuable Cards 思維

思路

我們可以設 \(dp\) 陣列,\(dp_i=1\) 表示 \(i\) 可以被之前的子序列的乘積表示。

那麼我們可以列舉 \(a_i\) ,如果滿足 x%a[i]==0&&dp[x/a[i]] 那麼就必須要新開一組。

接著我們只需要去維護好 \(dp\) 陣列即可。每次分組後我們需要清空 \(dp\) 陣列,但是全部清空顯然超時。

實際上對我們有用的只有 \(x\) 的因子。因此我們可以預處理出 \(x\) 的因子即可。

如果 \(a_i\)\(x\) 的因子,我們可以將所有 \(a_i \times d\)\(dp\) 狀態更新。其中 \(d\)\(x\) 的因子。

這裡更新的時候要注意,我們需要新開一個臨時 \(ndp\) 陣列。最後遍歷完,再用 \(ndp\) 陣列去更新 \(dp\) 陣列。

否則,就會造成新更新的值又去更新了別的值的情況。

程式碼

void Showball(){
    int n,x;
    cin>>n>>x;
    vector<int> a(n);
    for(int i=0;i<n;i++) cin>>a[i];
    vector<int> div;
	for(int i=2;i<=x/i;i++){
		if(x%i==0){
			div.pb(i);
			if(x/i!=i) div.pb(x/i);
		}
	}
    vector<int> dp(x+1);
	dp[1]=1;
	int ans=1;
	for(int i=0;i<n;i++){
		if(a[i]>x) continue;
		if(x%a[i]==0&&dp[x/a[i]]){
	   		for(auto d:div) dp[d]=0;
	   		ans++;
	   		dp[1]=1;
	   		dp[a[i]]=1;
	   		continue;
	   	}
	   	if(x%a[i]==0){
	    	vector<int> ndp(x+1);
	   		for(auto d:div) if(dp[d]&&1LL*a[i]*d<=x) dp[d*a[i]]=1;
	   	 	dp[a[i]]=1;
	   	 	for(auto d:div) dp[d]|=ndp[d];		
	   	}
	}
	cout<<ans<<endl;
}

G. Ultra-Meow 思維 + 組合數學

思路

直接算答案,不好下手。那麼我們可以考慮算貢獻。考慮列舉集合的大小 \(i\) 和最終的 \(mex\)\(j\)

需要滿足一下條件:

  1. 集合中不能含有 \(j\)
  2. 對於 \([1,j-1]\) 中的數字,要取 \(j-(i+1)\) 個。這樣才能保證再取 \(i+1\) 個就是 \(j\)
  3. 如果此時集合大小還沒有滿 \(i\) 個,那麼就從 \([j+1,n]\) 中選擇剩下的數字即可。

預處理出組合數,然後列舉計算即可。

那麼對於第 \(2\) 部分的貢獻就是 \(j*C[min(j-1,n)][j-i-1]\)

\(3\) 部分得到貢獻就是 \(C[n-j][i-cnt]\)

程式碼

#include<bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define pb push_back
#define all(u) u.begin(), u.end()
#define endl '\n'
#define debug(x) cout<<#x<<":"<<x<<endl;

typedef pair<int, int> PII;
typedef long long LL;
const int inf = 0x3f3f3f3f;
const int N = 5000 + 10, M = 105;
const int mod = 1e9 + 7;
const int cases = 1;

template<const int T>
struct ModInt {
    const static int mod = T;
    int x;
    ModInt(int x = 0) : x(x % mod) {}
    ModInt(long long x) : x(int(x % mod)) {} 
    int val() { return x; }
    ModInt operator + (const ModInt &a) const { int x0 = x + a.x; return ModInt(x0 < mod ? x0 : x0 - mod); }
    ModInt operator - (const ModInt &a) const { int x0 = x - a.x; return ModInt(x0 < 0 ? x0 + mod : x0); }
    ModInt operator * (const ModInt &a) const { return ModInt(1LL * x * a.x % mod); }
    ModInt operator / (const ModInt &a) const { return *this * a.inv(); }
    bool operator == (const ModInt &a) const { return x == a.x; };
    bool operator != (const ModInt &a) const { return x != a.x; };
    void operator += (const ModInt &a) { x += a.x; if (x >= mod) x -= mod; }
    void operator -= (const ModInt &a) { x -= a.x; if (x < 0) x += mod; }
    void operator *= (const ModInt &a) { x = 1LL * x * a.x % mod; }
    void operator /= (const ModInt &a) { *this = *this / a; }
    friend ModInt operator + (int y, const ModInt &a){ int x0 = y + a.x; return ModInt(x0 < mod ? x0 : x0 - mod); }
    friend ModInt operator - (int y, const ModInt &a){ int x0 = y - a.x; return ModInt(x0 < 0 ? x0 + mod : x0); }
    friend ModInt operator * (int y, const ModInt &a){ return ModInt(1LL * y * a.x % mod);}
    friend ModInt operator / (int y, const ModInt &a){ return ModInt(y) / a;}
    friend ostream &operator<<(ostream &os, const ModInt &a) { return os << a.x;}
    friend istream &operator>>(istream &is, ModInt &t){return is >> t.x;}

    ModInt pow(int64_t n) const {
        ModInt res(1), mul(x);
        while(n){
            if (n & 1) res *= mul;
            mul *= mul;
            n >>= 1;
        }
        return res;
    }
    
    ModInt inv() const {
        int a = x, b = mod, u = 1, v = 0;
        while (b) {
            int t = a / b;
            a -= t * b; swap(a, b);
            u -= t * v; swap(u, v);
        }
        if (u < 0) u += mod;
        return u;
    }
    
};
typedef ModInt<mod> mint;

mint C[N][N];
void init(){
    for(int i=0;i<N;i++){
        for(int j=0;j<=i;j++){
            if(!j) C[i][j]=1;
            else C[i][j]=C[i-1][j]+C[i-1][j-1];
        }
    }
}
void Showball(){
    int n;
    cin>>n;
    mint ans=1;
    for(int i=1;i<=n;i++){
    	for(int j=i+1;j<=2*i+1;j++){
    		int cnt=j-i-1;
    		mint t=j*C[min(j-1,n)][cnt];
    		if(j>n){
    			if(cnt!=i) t=0;
    		}else{
    			t*=C[n-j][i-cnt];
    		}
    		ans+=t;
    	}
    }
    cout<<ans<<endl;
}
int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int T=1;
    init();
    if(cases) cin>>T;
    while(T--)
    Showball();
    return 0;
}

相關文章